<?php
/*
Plugin Name: Spin de Texto
Plugin URI: https://snippetsboard.com/
Description: Permite espinear el texto gwnerado con el plugin page generator.
Author: WombatSEO
Author URI: https://snippetsboard.com/
Version: 1.0
License: GPLv2
*/

//FUncion para alterar el guardado de las entradas generadas con Page generator y añadirle la funcionalidad hacer spin al texto
function update_post_info( $post_id, $post, $update ) {
    //Analizamos que el status no se para enviarlo a eliminar. Esto impide que falle el sistema de borrado en modo bulk
    if ( 'trash' != get_post_status( $post_id ) ) {
        //Obtenemos el post type, ya que sólo vamos a trabajar con páginas
        $post_type = get_post_type($post_id);
        
        if ( $post_type == 'page') {
            //Si el tipo de publicción es página, altamos el contenido de la entrda por la salida de la función spinear
            $my_post = array(
                'ID'           => $post_id,
                'post_content'   => espinear($post->post_content),
            );
            if ( ! wp_is_post_revision( $post_id ) ) {
                    //esto impide el loop inficnito para las revisiones de post
                    remove_action('save_post', 'update_post_info');
                    wp_update_post( $my_post );
            }
        }
    }
}
add_action( 'save_post', 'update_post_info', 10, 3 );


function espinear($texto){
    $bucle = 0;
    $las_llaves = array('{','}');
    $vacios = array('','');
    while($bucle == 0) {
        preg_match('/{[^{}]*}/',$texto,$matches);
        $porciones = array_rand(array_flip(explode("|", str_replace($las_llaves,$vacios,$matches['0']))));
        $texto = preg_replace('/{[^{}]*}/', $porciones, $texto,1);
        
        if(substr_count($texto,'{') == 0){
            $bucle = 1;
            $texto = preg_replace('/[ ]{2,}/', ' ', $texto);
        }
    }
    return $texto;
}
?>